unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmDemo = class(TForm)
    lblBarcodeType: TLabel;
    cbxBarcodeType: TComboBox;
    lblData: TLabel;
    txtData: TEdit;
    chkApplyTilde: TCheckBox;
    lblApplyTilde: TLabel;
    txtBarcode: TMemo;
    txtHR: TMemo;
    btnDisplayBarcode: TButton;
    btnClose: TButton;
    procedure btnDisplayBarcodeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

function MW6Encode(BarcodeType: integer;
                   SourceText: PChar;
                   ApplyTilde: integer;
                   FormattedTextBuffer: PChar;
                   FTBSize: integer;
                   HumanReadableText: PChar;
                   HRTBSize: integer): integer;
         stdcall; far; external 'MW6FontEncoder.dll' name 'MW6Encode'

implementation

{$R *.dfm}

procedure TfrmDemo.btnDisplayBarcodeClick(Sender: TObject);
var
    barcodeType: integer;
    applyTilde: integer;
    formattedText: Array[0..1024] of Char;
    hrText: Array[0..1024] of Char;
    tmp: String;
begin

    // Sample string with tilde character: 12345~d0489876
    // ~dNNN is used to represent a character with ASCII value NNN
    // Sample GS1 128 string: (01)12345678901234(3103)123456
    if (chkApplyTilde.Checked) then
        applyTilde := 1
    else
        applyTilde := 0;

    barcodeType := cbxBarcodeType.ItemIndex + 100;
    MW6Encode(barcodeType, PChar(txtData.Text), applyTilde, @formattedText[0], 1024, @hrText[0], 1024);

    // set barcode text
    SetString(tmp, PChar(@formattedText[0]), Length(formattedText));
    txtBarcode.Text := tmp;

    // set human readable text
    SetString(tmp, PChar(@hrText[0]), Length(hrText));
    txtHR.Text := tmp;
end;

procedure TfrmDemo.FormShow(Sender: TObject);
begin
   cbxBarcodeType.ItemIndex := 0;
end;

procedure TfrmDemo.btnCloseClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
